<?php
class ControllerExtensionPaymentVepara extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/vepara');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_vepara', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['api_key'])) {
			$data['error_api_key'] = $this->error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		if (isset($this->error['api_secret'])) {
			$data['error_api_secret'] = $this->error['api_secret'];
		} else {
			$data['error_api_secret'] = '';
		}

		if (isset($this->error['type'])) {
			$data['error_type'] = $this->error['type'];
		} else {
			$data['error_type'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/vepara', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/vepara', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_vepara_merchant_id'])) {
			$data['payment_vepara_merchant_id'] = $this->request->post['payment_vepara_merchant_id'];
		} else {
			$data['payment_vepara_merchant_id'] = $this->config->get('payment_vepara_merchant_id');
		}

        if (isset($this->request->post['payment_vepara_merchant_key'])) {
            $data['payment_vepara_merchant_key'] = $this->request->post['payment_vepara_merchant_key'];
        } else {
            $data['payment_vepara_merchant_key'] = $this->config->get('payment_vepara_merchant_key');
        }

        if (isset($this->request->post['payment_vepara_app_key'])) {
            $data['payment_vepara_app_key'] = $this->request->post['payment_vepara_app_key'];
        } else {
            $data['payment_vepara_app_key'] = $this->config->get('payment_vepara_app_key');
        }

        if (isset($this->request->post['payment_vepara_app_secret'])) {
            $data['payment_vepara_app_secret'] = $this->request->post['payment_vepara_app_secret'];
        } else {
            $data['payment_vepara_app_secret'] = $this->config->get('payment_vepara_app_secret');
        }

        
        if (isset($this->request->post['payment_vepara_form_turu'])) {
            $data['payment_vepara_form_turu'] = $this->request->post['payment_vepara_form_turu'];
        } else {
            $data['payment_vepara_form_turu'] = $this->config->get('payment_vepara_form_turu');
        }

		if (isset($this->request->post['payment_vepara_mode'])) {
			$data['payment_vepara_mode'] = $this->request->post['payment_vepara_mode'];
		} else {
			$data['payment_vepara_mode'] = $this->config->get('payment_vepara_mode');
		}

		if (isset($this->request->post['payment_vepara_type'])) {
			$data['payment_vepara_type'] = $this->request->post['payment_vepara_type'];
		} else {
			$data['payment_vepara_type'] = $this->config->get('payment_vepara_type');
		}

		if (isset($this->request->post['payment_vepara_total'])) {
			$data['payment_vepara_total'] = $this->request->post['payment_vepara_total'];
		} else {
			$data['payment_vepara_total'] = $this->config->get('payment_vepara_total');
		}

		if (isset($this->request->post['payment_vepara_order_status_id'])) {
			$data['payment_vepara_order_status_id'] = $this->request->post['payment_vepara_order_status_id'];
		} else {
			$data['payment_vepara_order_status_id'] = $this->config->get('payment_vepara_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_vepara_geo_zone_id'])) {
			$data['payment_vepara_geo_zone_id'] = $this->request->post['payment_vepara_geo_zone_id'];
		} else {
			$data['payment_vepara_geo_zone_id'] = $this->config->get('payment_vepara_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_vepara_status'])) {
			$data['payment_vepara_status'] = $this->request->post['payment_vepara_status'];
		} else {
			$data['payment_vepara_status'] = $this->config->get('payment_vepara_status');
		}

		if (isset($this->request->post['payment_vepara_sort_order'])) {
			$data['payment_vepara_sort_order'] = $this->request->post['payment_vepara_sort_order'];
		} else {
			$data['payment_vepara_sort_order'] = $this->config->get('payment_vepara_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/vepara', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/vepara')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}


		return !$this->error;
	}
}