<?php

    class ControllerExtensionPaymentVepara extends Controller
    {
        public $base_url, $installment_api_url, $initialize_api_url, $complete_api_url, $return_url;


        public function index()
        {
            $this->checkAndSetCookieSameSite();
            $store_id = $this->config->get('config_store_id');
            $language_id = $this->config->get('config_language_id');


            $data['button_confirm'] = $this->language->get('button_confirm');

            $this->load->model('checkout/order');

            $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

            /*
             * Eğer Form türü ödeme formu ise
             */

            $url = "index.php?route=extension/payment/vepara/start3d";

            $data['action'] = $url;
            $data['payment_vepara_form_turu'] = $this->config->get('payment_vepara_form_turu');
            // $callback = $this->url->link('nkolay-back-4875875454545', '', true);

            // $callback = str_replace('index.php?route=', '', $callback);
            $callback = $this->url->link('extension/payment/vepara/callback', '', true);
            $sx = $this->config->get('payment_vepara_sx');
            $merchantSecretKey = $this->config->get('payment_vepara_secret');
            $successUrl = $callback;
            $failUrl = $callback;
            $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
            $clientRefCode = $this->session->data['order_id'] . "|OP|" . uniqid();
            $productId = $this->config->get('payment_vepara_payment');
            $use3D = $this->config->get('payment_vepara_type') == '3D' ? 'true' : 'false';
            $rnd = date("d.m.Y H:i:s");
            $detail = "false";
            $transactionType = "SALES";

            $hashstr = $sx . $clientRefCode . $amount . $successUrl . $failUrl . $rnd . $merchantSecretKey;

            $hashData = base64_encode(pack('H*', sha1($hashstr)));

            $data['amount'] = $amount;
            $data['clientRefCode'] = $clientRefCode;
            $data['data'] = [
                'sx' => $sx,
                'successUrl' => $successUrl,
                'failUrl' => $failUrl,
                'amount' => $amount,
                'clientRefCode' => $clientRefCode,
                'productId' => $productId,
                'use3D' => $use3D,
                'rnd' => $rnd,
                'detail' => $detail,
                'transactionType' => $transactionType,
                'hashData' => $hashData,
            ];

            $base_url = explode("index.php", $_SERVER['HTTP_REFERER'])[0];
            $data['css1'] = $base_url . "catalog/view/javascript/vepara/vepara_form.css";
            $data['css2'] = $base_url . "catalog/view/javascript/vepara/vepara_icons.css";

            return $this->load->view('extension/payment/vepara', $data);
        }

        public function callback()
        {


            $url = "https://test.vepara.com.tr/ccpayment";
            if ($this->config->get('payment_vepara_mode') == 1) {
                $url = "https://app.vepara.com.tr/ccpayment";
            }


            $merchantSecretKey = $this->config->get('payment_vepara_secret');

            $REFERENCE_CODE = $this->request->post['REFERENCE_CODE'];
            $RESPONSE_CODE = $this->request->post['RESPONSE_CODE'];
            $USE_3D = $this->request->post['USE_3D'];
            $MERCHANT_NO = $this->request->post['MERCHANT_NO'];
            $AUTH_CODE = $this->request->post['AUTH_CODE'];
            $CLIENT_REFERENCE_CODE = $this->request->post['CLIENT_REFERENCE_CODE'];
            $AUTHORIZATION_AMOUNT = $this->request->post['AUTHORIZATION_AMOUNT'];
            $INSTALLMENT = $this->request->post['INSTALLMENT'];
            $RND = $this->request->post['RND'];
            $hashData = $this->request->post['hashData'];
            $merchantSecretKey;
            $order_id = explode('|OP|', $CLIENT_REFERENCE_CODE);

            $hashtr = $MERCHANT_NO . $REFERENCE_CODE . $AUTH_CODE . $RESPONSE_CODE . $USE_3D . $RND . $INSTALLMENT . $AUTHORIZATION_AMOUNT . $merchantSecretKey;
            $hashDatauretilen = base64_encode(pack('H*', sha1($hashtr)));


            if ($this->request->post['USE_3D'] == 'false' && $this->request->post['hashData'] == $hashDatauretilen) {


                if ($this->request->post['RESPONSE_CODE'] == 2 && $this->request->post['hashData'] == $hashDatauretilen) {
                    $this->load->model('checkout/order');

                    $this->model_checkout_order->addOrderHistory(current($order_id), $this->config->get('payment_vepara_order_status_id'));
                    $this->response->redirect($this->url->link('checkout/success', '', true));
                } else {
                    $this->session->data['error'] = $this->request->post['RESPONSE_DATA'];

                    $this->response->redirect($this->url->link('checkout/cart'));
                }
            } else {
                if ($this->request->post['RESPONSE_CODE'] == 2 && $this->request->post['hashData'] == $hashDatauretilen) {

                    $ch = curl_init();
                    $arrData = array(
                        "sx" => $this->config->get('payment_vepara_sx'),
                        "referenceCode" => $REFERENCE_CODE
                    );
                    curl_setopt($ch, CURLOPT_URL, $url);
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $arrData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $server_output = curl_exec($ch);

                    $result = json_decode($server_output);
                    $result = json_decode($result->result);

                    if ($result->RESPONSE_CODE == 2) {
                        $this->load->model('checkout/order');
                        $this->model_checkout_order->addOrderHistory(current($order_id), $this->config->get('payment_vepara_order_status_id'));
                        $this->response->redirect($this->url->link('checkout/success', '', true));
                    } else {
                        $this->session->data['error'] = $result->RESPONSE_DATA;
                        $this->response->redirect($this->url->link('checkout/cart'));
                    }


                } else {
                    $this->session->data['error'] = $this->request->post['RESPONSE_DATA'];

                    $this->response->redirect($this->url->link('checkout/cart'));
                }
            }


        }


        public function getToken()
        {
            if ($this->config->get('payment_vepara_mode') == 1) {
                $url = "https://app.vepara.com.tr/ccpayment/api/token";
            } else {
                $url = "https://test.vepara.com.tr/ccpayment/api/token";
            }


            $par = [
                'app_id' => $this->config->get('payment_vepara_app_key'),
                'app_secret' => $this->config->get('payment_vepara_app_secret'),
            ];

            return $this->curl($par, $url);
        }


        public function getInstall()
        {
            if ($this->config->get('payment_vepara_mode') == 1) {
                $url = "https://app.vepara.com.tr/ccpayment/api/getpos";
            } else {
                $url = "https://test.vepara.com.tr/ccpayment/api/getpos";
            }


            $token_result = json_decode($this->getToken());


            if ($token_result->status_code == 100) {
                $token = $token_result->data->token;

                $par = [
                    'merchant_key' => $this->config->get('payment_vepara_merchant_key'),
                    'amount' => $_REQUEST['amount'],
                    'credit_card' => trim($_REQUEST['cardnumber']),
                    'currency_code' => "TRY",
                ];

                $installament = json_decode($this->curl($par, $url, $token));


                if ($installament->status_code == 100) {

                    $html = '<input type="hidden" id="CARD_SCOPE" value="D">';
                    $html .= '<input type="hidden" id="CURRENCY_CODE_LIST" value=" != null">';
                    $html .= '<div class="col wid100" id="tlist">';
                    $html .= '<table class="table border rounded bg-white">';
                    $html .= '<tbody>';


                    foreach ($installament->data as $key => $taksitler) {
                        if ($taksitler->installments_number == 1) {
                            $text_value = "Tek Çekim";
                        } else {
                            $text_value = $taksitler->installments_number . " x " . $taksitler->payable_amount;
                        }
                        $total = $taksitler->amount_to_be_paid;
                        if (empty(explode(".", $total)[1])) {
                            $total = $total . ".00";
                        } else {
                            if (strlen(explode(".", $total)[1]) == 1) {
                                $total = $total . "0";
                            }
                        }

                        $html .= '<tr><td class="px-3 py-2"><div class="form-check">';
                        $html .= '<input type="radio" data-sayi="' . $taksitler->installments_number . '" id="tno' . $taksitler->installments_number . '" ';
                        $html .= 'onclick="updateSubmitButtonAmount(\'' . $total . '\')" class="form-check-input p-1" name="tno"';
                        if ($taksitler->installments_number == 1) {
                            $html .= 'checked';
                        }
                        $html .= 'value="' . $taksitler->installments_number . '"';
                        $html .= 'tag="' . $total . '"';
                        $html .= '<label class="form-check-label" for="tno' . $taksitler->installments_number . '"><strong>' . $text_value . '</strong></label></div></td>';

                        $html .= '<td class="px-3 py-2" id="instalmentTd' . $key . '"><label for="tno1">' . $total . ' ₺ </label></td>';
                        $html .= '<td class="px-3 py-2 text-primary"><strong></strong></td></tr>';
                        $html .= '<input type="hidden" name="tsx' . $taksitler->installments_number . '" value="' . $taksitler->hash_key . '">';
                    }


                    $html .= '</tbody></table></div>';

                    echo $html;
                }


            }


        }


        public function start3d()
        {


            if ($this->config->get('payment_vepara_mode') == 1) {
                $url = "https://app.vepara.com.tr/ccpayment/api/paySmart3D";
            } else {
                $url = "https://test.vepara.com.tr/ccpayment/api/paySmart3D";
            }


            $order_id = (string)explode("|", $_REQUEST['order_id'])[0];

            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($order_id);
            $amount = floatval($this->amountTemizle($_REQUEST['odenecek_tutar']));

            if ($order_info) {
                $item_data = [];
                $products = $this->model_checkout_order->getOrderProducts($order_id);
                foreach ($products as $product) {
                    $price = str_replace(".0000", "", $product['price']);
                    $price = str_replace(".00", "", $price);
                    $item_data[] = array(
                        'price' => $price,
                        'name' => $product['name'],
                        'quantity' => intval($product['quantity']),
                        'description' => $product['name'] . " ürünü"
                    );
                }
            }

            $shipping_total = 0;
            $order_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order WHERE order_id = '" . (int)$order_id . "'");
            if ($order_query->num_rows) {
                $order_total_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_total WHERE order_id = '" . (int)$order_id . "' AND code = 'shipping'");
                if ($order_total_query->num_rows) {
                    $shipping_total = $order_total_query->row['value'];
                }
            }

            if ($shipping_total > 0) {
                $item_data[] = array(
                    'price' => str_replace(".0000", "", $shipping_total),
                    'name' => "Kargo",
                    'quantity' => 1,
                    'description' => "Kargo ücreti"
                );
            }


            $item_data = json_encode($item_data);



            $vars = [
                'cc_holder_name' => $_REQUEST['cardHolderName'],
                'cc_no' => str_replace(" ", "", $_REQUEST['cardNumber']),
                'expiry_month' => $_REQUEST['ay'],
                'expiry_year' => $_REQUEST['yil'],
                'cvv' => $_REQUEST['cvv'],
                'currency_code' => "TRY",
                'installments_number' => intval($_REQUEST['secilen_taksit']),
                'invoice_id' => $order_id,
                'invoice_description' => $order_id . " Nolu Sipariş Ödemesi",
                'name' => $order_info['payment_firstname'],
                'surname' => $order_info['payment_lastname'],
                'total' => $amount,
                'merchant_key' => $this->config->get('payment_vepara_merchant_key'),
                'items' => $item_data,
                'return_url' => (string)$this->url->link('extension/payment/vepara/completePayment', '', true),
                'cancel_url' => (string)$this->url->link('extension/payment/vepara/completePayment', '', true),
                'hash_key' => $this->generateHash($amount, $_REQUEST['secilen_taksit'], "TRY", $this->config->get('payment_parolapara_merchant_key'), $order_id, $this->config->get('payment_parolapara_app_secret')),
                'bill_address1' => $order_info['payment_address_1'],
                'bill_address2' => $order_info['payment_address_2'],
                'bill_city' => $order_info['payment_zone'],
                'bill_postcode' => $order_info['payment_postcode'],
                'bill_state' => $order_info['payment_city'],
                'bill_country' => "Türkiye",
                'bill_email' => $order_info['email'],
                'bill_phone' => str_replace("+90", "", $order_info['telephone']),
                'card_program' => '',
                'ip' => $this->getIp(),
                'transaction_type' => "Auth",
                'sale_webhook_key' => $order_id,
                'payment_completed_by' => "app",
                'response_method' => "POST",
            ];


            ?>

            <style>
                /* Absolute Center Spinner */
                .loading {
                    position: fixed;
                    z-index: 999;
                    height: 2em;
                    width: 2em;
                    overflow: visible;
                    margin: auto;
                    top: 0;
                    left: 0;
                    bottom: 0;
                    right: 0;
                }

                /* Transparent Overlay */
                .loading:before {
                    content: '';
                    display: block;
                    position: fixed;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    background-color: rgba(0, 0, 0, 0.3);
                }

                /* :not(:required) hides these rules from IE9 and below */
                .loading:not(:required) {
                    /* hide "loading..." text */
                    font: 0/0 a;
                    color: transparent;
                    text-shadow: none;
                    background-color: transparent;
                    border: 0;
                }

                .loading:not(:required):after {
                    content: '';
                    display: block;
                    font-size: 10px;
                    width: 1em;
                    height: 1em;
                    margin-top: -0.5em;
                    -webkit-animation: spinner 1500ms infinite linear;
                    -moz-animation: spinner 1500ms infinite linear;
                    -ms-animation: spinner 1500ms infinite linear;
                    -o-animation: spinner 1500ms infinite linear;
                    animation: spinner 1500ms infinite linear;
                    border-radius: 0.5em;
                    -webkit-box-shadow: rgba(0, 0, 0, 0.75) 1.5em 0 0 0, rgba(0, 0, 0, 0.75) 1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) 0 1.5em 0 0, rgba(0, 0, 0, 0.75) -1.1em 1.1em 0 0, rgba(0, 0, 0, 0.5) -1.5em 0 0 0, rgba(0, 0, 0, 0.5) -1.1em -1.1em 0 0, rgba(0, 0, 0, 0.75) 0 -1.5em 0 0, rgba(0, 0, 0, 0.75) 1.1em -1.1em 0 0;
                    box-shadow: rgba(0, 0, 0, 0.75) 1.5em 0 0 0, rgba(0, 0, 0, 0.75) 1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) 0 1.5em 0 0, rgba(0, 0, 0, 0.75) -1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) -1.5em 0 0 0, rgba(0, 0, 0, 0.75) -1.1em -1.1em 0 0, rgba(0, 0, 0, 0.75) 0 -1.5em 0 0, rgba(0, 0, 0, 0.75) 1.1em -1.1em 0 0;
                }

                /* Animation */

                @-webkit-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @-moz-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @-o-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }
            </style>
            <div class="loading">Loading&#8230;</div>
            <form action="<?php echo $url ?>" method="post"><?php
                    foreach ($vars as $key => $value) {
                        echo "<input type='hidden' name='" . $key . "' value='" . $value . "'>";
                    }
                ?>
                <input type="submit" value="GÖNDER" id="devam" style="display: none">
            </form>
            <script>
                document.getElementById("devam").click();
            </script><?php


            exit;
        }

        /*
         * 3d ödemeyi tamamlar ve ödeme başarılı sayfasına yönlendirir
         */
        public function completePayment()
        {


            $url = "https://app.vepara.com.tr/ccpayment/api/complete";
            if ($this->config->get('payment_vepara_mode') == 0) {
                $url = "https://test.vepara.com.tr/ccpayment/api/complete";
            }

            $sonuc = $this->validateHashKey($_REQUEST['hash_key']);


            if ($sonuc['0'] == $_REQUEST['payment_status'] && $sonuc['2'] == $_REQUEST['invoice_id'] && $sonuc['3'] == $_REQUEST['order_id']) {

                if ($_REQUEST['transaction_type'] == "Auth" && $_REQUEST['payment_status'] == 1) {


                    $order_id = $_REQUEST['invoice_id'];
                    $this->load->model('checkout/order');
                    $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_vepara_order_status_id'));
                    $this->response->redirect($this->url->link('checkout/success', '', true));

                    exit;
                    $token_result = json_decode($this->getToken());


                    if ($token_result->status_code == 100) {
                        $token = $token_result->data->token;
                        $array = [
                            'merchant_key' => $this->config->get('payment_vepara_merchant_key'),
                            'invoice_id' => $_REQUEST['invoice_id'],
                            'order_id' => $_REQUEST['order_no'],
                            'status' => "Complete",
                        ];

                        $sonuc = $this->curl($array, $url, $token);

                        if ($sonuc->status_code == 100) {
                            $order_id = $_REQUEST['invoice_id'];
                            $this->load->model('checkout/order');
                            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_vepara_order_status_id'));
                            $this->response->redirect($this->url->link('checkout/success', '', true));

                        } else {

                            $this->session->data['error'] = $_REQUEST['status_description'];
                            $this->response->redirect($this->url->link('checkout/checkout'));

                        }
                    }


                } else {
                    $this->session->data['error'] = $_REQUEST['status_description'];
                    $this->response->redirect($this->url->link('checkout/checkout'));
                }

            } else {
                echo "hash doğrulanamadı";
                exit;
            }


            if (empty($_REQUEST['error'])) {
                $url = "https://app.vepara.com.tr/ccpayment/api/complete";
                if ($this->config->get('payment_vepara_mode') == 0) {
                    $url = "https://test.vepara.com.tr/ccpayment/api/complete";
                }

                $json_par = json_encode(array(
                    'clientIpAddress' => $this->getIp(),
                    'paymentId' => $_REQUEST['oid'],
                ));
                $hash_data = $_REQUEST['oid'];
                $result = $this->curl($json_par, $url, $hash_data);


                if ($result->data->status == "Sale") {
                    $order_id = $result->data->orderId;
                    $this->load->model('checkout/order');
                    $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_vepara_order_status_id'));
                    $this->response->redirect($this->url->link('checkout/success', '', true));
                } else {

                    $this->session->data['error'] = $result->data->message;
                    $this->response->redirect($this->url->link('checkout/checkout'));
                }
            } else if (isset($_REQUEST['status_description'])) {
                $this->session->data['error'] = $_REQUEST['status_description'];
                $this->response->redirect($this->url->link('checkout/checkout'));
            }
            exit;

        }


        public function curl($payload, $url, $token = "")
        {
            if (!empty($token)) {
                $header = [
                    "Authorization: Bearer $token", "Accept: application/json", "Content-Type: application/json"
                ];
            } else {
                $header = ['Content-Type: application/json'];
            }
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_HTTPHEADER, array());
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
            $output = curl_exec($ch);
            curl_close($ch);
            return $output;
        }

        public function generateHash($total, $installment, $currency_code, $merchant_key, $invoice_id, $app_secret)
        {

            $data = $total . '|' . $installment . '|' . $currency_code . '|' . $merchant_key . '|' . $invoice_id;
            $iv = substr(sha1(mt_rand()), 0, 16);
            $password = sha1($app_secret);
            $salt = substr(sha1(mt_rand()), 0, 4);
            $saltWithPassword = hash('sha256', $password . $salt);
            $encrypted = openssl_encrypt(
                "$data", 'aes-256-cbc', "$saltWithPassword", 0, $iv
            );
            $msg_encrypted_bundle = "$iv:$salt:$encrypted";
            $msg_encrypted_bundle = str_replace('/', '__', $msg_encrypted_bundle);
            return $msg_encrypted_bundle;
        }

        function validateHashKey($hashKey)
        {
            $secretKey = $this->config->get('payment_vepara_app_secret');

            $status = $currencyCode = "";
            $total = $invoiceId = $orderId = 0;
            if (empty(!$hashKey)) {
                $hashkey = str_replace('__', '/', $hashKey);
                $password = sha1($secretKey);
                $components = explode(':', $hashkey);
                if (count($components) > 2) {
                    $iv = isset($components[0]) ? $components[0] : "";
                    $salt = isset($components[1]) ? $components[1] : "";
                    $salt = hash('sha256', $password . $salt);
                    $encryptedMsg = isset($components[2]) ? $components[2] : "";
                    $decryptedMsg = openssl_decrypt($encryptedMsg, 'aes-256-cbc', $salt, null, $iv);
                    if (strpos($decryptedMsg, '|') !== false) {
                        $array = explode('|', $decryptedMsg);
                        $status = isset($array[0]) ? $array[0] : 0;
                        $total = isset($array[1]) ? $array[1] : 0;
                        $invoiceId = isset($array[2]) ? $array[2] : '0';
                        $orderId = isset($array[3]) ? $array[3] : 0;
                        $currencyCode = isset($array[4]) ? $array[4] : '';
                    }
                    return [$status, $total, $invoiceId, $orderId, $currencyCode];
                }
            }
        }

        public function getIp()
        {
            if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
                $ip = $_SERVER['HTTP_CLIENT_IP'];
            } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
            } else {
                $ip = $_SERVER['REMOTE_ADDR'];
            }

            return $ip;
        }

        public function amountTemizle($amount)
        {
            $amount = trim($amount);
            $amount = str_replace(".0000", "", $amount);
            $amount = str_replace(".00", "", $amount);
            return $amount;
        }


        private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly)
        {

            if (PHP_VERSION_ID < 70300) {

                setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
            } else {
                setcookie($name, $value, [
                    'expires' => $expire,
                    'path' => $path,
                    'domain' => $domain,
                    'samesite' => 'None',
                    'secure' => $secure,
                    'httponly' => $httponly
                ]);


            }
        }

        private function checkAndSetCookieSameSite()
        {

            $checkCookieNames = array('PHPSESSID', 'OCSESSID', 'default', 'PrestaShop-', 'wp_woocommerce_session_');

            foreach ($_COOKIE as $cookieName => $value) {
                foreach ($checkCookieNames as $checkCookieName) {
                    if (stripos($cookieName, $checkCookieName) === 0) {
                        $this->setcookieSameSite($cookieName, $_COOKIE[$cookieName], time() + 86400, "/", $_SERVER['SERVER_NAME'], true, true);
                    }
                }
            }
        }
    }